/*************************************************************************/
/* Fusion de 2 listes, sous les conditions suivantes:                    */
/*            - n1, n2, n3 donnent le nombre d'élément effectifs de      */
/*              chacune des 3 listes. Chacune des " variables L1, L2, L3 */
/*              doit avoir été dimensionnée à une valeur supérieur à     */
/*              n1, n2, n3 (respectivement)                              */
/*            - les 2 listes DOIVENT être en ordre CROISSANT AVANT       */
/*                 l'appel de la fonsction fusion_listes                 */
/*            - il peut y avoir des répétitions de valeurs, tant         */
/*                 dans les suites à fusionner que dans le résultat      */
/*            - tous les éléments sont fusionnés: en conséquence, la     */
/*              valeur de l'entier d'adresse n3 sera mise à n1+n2        */
/*************************************************************************/
#include <stdio.h>
void fusion_listes(int L1[ ], int L2[ ], int L3[ ], int n1, int n2, int * n3)
{ int i1, i2, i3;
  i1=i2=i3=0;
  while ((i1<n1) || (i2<n2))
  if ((i1<n1) && (i2<n2))
    if (L1[i1] < L2[i2]) L3[i3++] = L1[i1++];
    else L3[i3++] = L2[i2++];
  else if (i1==n1) L3[i3++]= L2[i2++];
       else L3[i3++] = L1[i1++];
  *n3 = i3;
}

void union_ensembles(int L1[ ], int L2[ ], int L3[ ], int n1, int n2, int * n3)
{ int i1, i2, i3;
  i1=i2=i3=0;
  while ((i1<n1) || (i2<n2))
  if ((i1<n1) && (i2<n2))
    if (L1[i1] < L2[i2]) L3[i3++] = L1[i1++];
    else if (L1[i1] > L2[i2]) L3[i3++] = L2[i2++];
         else i1++;
  else if (i1==n1) L3[i3++]= L2[i2++];
       else L3[i3++] = L1[i1++];
  *n3 = i3;
}

void inter_ensembles(int L1[ ], int L2[ ], int L3[ ], int n1, int n2, int * n3)
{ int i1, i2, i3;
  i1=i2=i3=0;
  while ((i1<n1) && (i2<n2))
    if (L1[i1] < L2[i2]) i1++;
    else if (L1[i1] > L2[i2]) i2++;
         else {L3[i3++] = L2[i2++];i1++;}
  *n3 = i3;
}

void affiche_n_vect(int V[ ], int n)
{ int i;
  for (i=0; i<n; i++) printf("%d  ", V[i]);
  printf("\n");
}
main()
{ /* programme simplement destiné à tester la fusion de 2 listes */
  const int NMAX=100;
  int S1[ ] = {1, 2, 7, 11, 17, 19, 23, 32, 56}, p1=9;
  int S2[ ] = {2, 5, 7, 11, 12, 13, 14, 23, 25, 27, 29, 32, 37, 41}, p2=14;
  int S3[NMAX], p3;
  printf("1ère suite: ");
  affiche_n_vect(S1,p1);
  printf("2ème suite: ");
  affiche_n_vect(S2,p2);
  fusion_listes(S1, S2, S3, p1, p2, &p3);
  printf("fusion des 2 listes: ");
  affiche_n_vect(S3,p3);
  union_ensembles(S1, S2, S3, p1, p2, &p3);
  printf("union des 2 ensembles: ");
  affiche_n_vect(S3,p3);
  inter_ensembles(S1, S2, S3, p1, p2, &p3);
  printf("intersection des 2 ensembles: ");
  affiche_n_vect(S3,p3);
}
