#include<stdio.h>


#define QUES 40 //Nombre de questions MULTIPLE DE 10 OBLIGATOIRE
#define ITEM 4  //Nombre d'items par question
#define LSUJ 400 // 2*(ITEM + 1)*QUES
#define LQ   200 // Nb de caracteres max d'une question ou d'un item
#define NSUJET  8 // Nb de sujets


int ordreQues[QUES]; // Permutation des questions pour un sujet 
int ordreItem[ITEM]; // Permutation des items pour une question 
int ordreItemInv[ITEM]; // Permutation des items pour une question 

char sujet[LSUJ][LQ]; //Un qcm melange
int rep[QUES]; // Les reponses pour le sujet en cours

FILE *fichG; // Fichier generique utilise pour des copies
FILE *sourceQCM; // Le fichier source du qcm
FILE *destS; // Le fichier avec le sujet
FILE *destC; // Le fichier avec le corrige



/*
  Rempli le tableau sujet a partir du fichier source
*/

captSource(){
  int i;
  int j;
  
  sourceQCM = fopen("qcm.tex", "r");

  j=0;

  for (i=0; i<LSUJ; i++){
    fgets(sujet[i], LQ, sourceQCM);
  
    if (sujet[i][0] == '%') {rep[j] = sujet[i][1]-'1'; j++;} //Capte la bonne rponse
  }

  fclose(sourceQCM);
}


/*
  Met dans odreQues une permutation aleatoire des questions
*/
gen1ques(){
  int i, j;

  int c;
  int tques[QUES];
 
  for (i=0; i<QUES; i++) tques[i]=i;

  for (i=0; i<QUES; i++){
    c = rand() % (QUES-i);
    ordreQues[i] = tques[c];
    for (j=c; j<QUES-i; j++){
      tques[j] = tques[j+1];
    }
  }
}


/*
  Met dans odreItem une permutation aleatoire des Items
*/
gen1item(){
  int i, j;

  int c;
  int titem[ITEM];
 
  for (i=0; i<ITEM; i++) titem[i]=i;

  for (i=0; i<ITEM; i++){
    c = rand() % (ITEM-i);
    ordreItem[i] = titem[c];
    ordreItemInv[titem[c]] = i; //Pour l'inverse
    for (j=c; j<ITEM-i; j++){
      titem[j] = titem[j+1];
    }
  }
}


/*
  Ecrit le qcm conformement aux permutations
*/
ecrit1qcm(){
  int i, j;
  
  gen1ques(); //On melange les questions
  
  for (i=0; i<QUES; i++){
    fprintf(destS, "\n\n\\vspace{1ex}\n\n\\parbox{15cm}{%");
    fprintf(destS, "%s\n", sujet[2*ordreQues[i]*(ITEM+1)]);
    gen1item(); //On melange les items
    for (j=0; j<ITEM; j++){
      fprintf(destS, "%s\n", 
	      sujet[2*ordreQues[i]*(ITEM+1)+2*ordreItem[j] + 2]);  
    }
    fprintf(destS, "}\n\n");
    if (i%10 == 9)
      fprintf(destC, "%i\\s %c \\\\ \\hline", i+1, 'a'  +  
	      ordreItemInv[rep[ordreQues[i]]]);
    else
      fprintf(destC, "%i\\s %c &", i+1, 'a'  +
	      ordreItemInv[rep[ordreQues[i]]]);
  }  
}


main(){
  int i,j;
  char c;

  destS = fopen("nsujet.tex", "w");
  destC = fopen("ncorrige.tex", "w");
  
  
  // On recopie l'entete generale (pour le sujet et le corrige)
  fichG = fopen("enteteSujet.tex", "r");
  while ( (c=fgetc(fichG)) != EOF ) 
    fputc(c, destS);
  fclose(fichG);
  
  sourceQCM = fopen("enteteCorrige.tex", "r");
  while ( (c=fgetc(fichG)) != EOF ) 
    fputc(c, destC);
  fclose(fichG);
  
  // On cree les NSUJET sujets
  for (i=1; i<=NSUJET; i++){
    // Premiere ligne du sujet, avec son numero
    fprintf(destS, "{\\noindent\\Huge\\bf Sujet \\no %i\\\\}", i);
    fprintf(destS, "\\vspace{2ex}");
    fprintf(destC, "{\\noindent\\Huge\\bf Corrig du Sujet \\no %i\\\\}", i);
    fprintf(destC, "\\vspace{2ex}");
 

    // Titre etc
    fichG = fopen("debsujet.tex", "r");
    while ( (c=fgetc(fichG)) != EOF ) 
      fputc(c, destS);
    fclose(fichG);

    // Annonce du QCM
    fichG = fopen("suiteSujet.tex", "r");
    while ( (c=fgetc(fichG)) != EOF ) 
      fputc(c, destS);
    fclose(fichG);

    captSource();
    //Ecriture du qcm
    fprintf(destC, "{\\center\\begin{tabular}{|l|l|l|l|l|l|l|l|l|l|}\\hline");      
    ecrit1qcm();
    fprintf(destC, "\\end{tabular} }\\newpage");  
  
    fichG = fopen("finsujet.tex", "r");
    while ( (c=fgetc(fichG)) != EOF ) 
      fputc(c, destS);
    fclose(fichG);
  }

  
  // Fin generale
  fichG = fopen("pied.tex", "r");
  while ( (c=fgetc(fichG)) != EOF ) 
    fputc(c, destS);
  fclose(fichG);

  fichG = fopen("piedCorrige.tex", "r");
  while ( (c=fgetc(fichG)) != EOF ) 
    fputc(c, destC);
  fclose(fichG);
  
  fclose(destS);
  fclose(destC);
}
